//
//  TableViewControllerRegistroPerros.swift
//  MyKennel
//
//  Created by Juan Antonio Sánchez Carrillo on 31/5/15.
//  Copyright (c) 2015 Juan Antonio Sánchez Carrillo. All rights reserved.
//

import UIKit
import CoreData


class TableViewControllerRegistroPerros: UITableViewController {

    //Declaro Array para almacenar los datos de la tabla
    var datosConsultaPerros : Array<AnyObject> = []
    
    //Declaro Constante que almacena el alto de la celda
    let alturaCelda: CGFloat = 80.0
    
    //Función para presentar datos en la vista de tabla cuando esta se cargue
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(true)
    
    //Declaro constante de la case AppDelegate
        let appdel : AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        
    //Declaro Constante del Managed Object Context
        let managedObjectContexto : NSManagedObjectContext = appdel.managedObjectContext!
        
    //Declaro Constante de la clase NSFetchrequest para la consulta de datos.
        let frequest = NSFetchRequest(entityName: "Perros")
    
    //Cargo el Array y hago la consulta
        datosConsultaPerros = managedObjectContexto.executeFetchRequest(frequest,error : nil)!
        
    //Vuelvo a cargar la Tabla
        tableView.reloadData()
        
    }
    
    
    //MARK: - Métodos Propios
    
    //Método que hace que se presenten en los textField los datos al pasar a la vista de detalle
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject!) {
        //Condicional para ver si el identificador es el mismo
        if segue.identifier == "actualizaPerros" {
        //Variable para almacenar el índice de la tabla
            var indexPath : NSIndexPath = self.tableView.indexPathForSelectedRow()!
        //Creo Objeto para la clase NSManagedObject y le paso el array y la fila seleccionada
            var selectedItem : NSManagedObject = datosConsultaPerros[indexPath.row] as! NSManagedObject
        //Presento la vista de Detalle
            let vistaDetallePerros : ViewControllerDetallePerros = segue.destinationViewController as! ViewControllerDetallePerros
        //Paso el valor seleccionado en la propiedad SelectItem
            vistaDetallePerros.nombrePerro = selectedItem.valueForKey("nombre") as? String
            vistaDetallePerros.afijoPerro = selectedItem.valueForKey("afijo") as? String
            vistaDetallePerros.padrePerro = selectedItem.valueForKey("padre") as? String
            vistaDetallePerros.madrePerro = selectedItem.valueForKey("madre") as? String
            vistaDetallePerros.chip = selectedItem.valueForKey("chip") as? String
            vistaDetallePerros.loe = selectedItem.valueForKey("libroOrigenes") as? String
            vistaDetallePerros.sexo = selectedItem.valueForKey("sexo") as? String
            vistaDetallePerros.nacimiento = selectedItem.valueForKey("nacimiento") as? String
            vistaDetallePerros.defuncion = selectedItem.valueForKey("defuncion") as? String
            vistaDetallePerros.imagen = selectedItem.valueForKey("imagen") as? UIImage

            vistaDetallePerros.existePerro = selectedItem


            
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
        // self.navigationItem.rightBarButtonItem = self.editButtonItem()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: - Table view data source

    override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        // #warning Potentially incomplete method implementation.
        // Return the number of sections.
        return 1
    }

    override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete method implementation.
        // Return the number of rows in the section.
        return datosConsultaPerros.count
    }

    
    override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        //Identificador de Celda
        let CellID: NSString = "Cell"
        
        //Paso Identificador de celda
        var cell: UITableViewCell = tableView.dequeueReusableCellWithIdentifier(CellID as String) as! UITableViewCell
        
        //Creo objeto NSManagedObject
        var datos: NSManagedObject = datosConsultaPerros[indexPath.row] as! NSManagedObject
        
        //String que almacena Nombre del Perro
        var nombre = datos.valueForKeyPath("nombre") as! String
        
        //String que almacena el Afijo del Perro
        var afijo = datos.valueForKeyPath("afijo") as! String
        
        //Guardo nombre+afijo
        var nombreAfijo = nombre.stringByAppendingString(" \(afijo)")
        
        //Imagen del perro
        var imagen : UIImage = UIImage(data: datos.valueForKeyPath("imagen") as! NSData)!
        
        //Creo Constante para establecer un tipo de fuente y su tamaño
        let font: UIFont = UIFont (name: "AvenirNext-Regular",size:16.0)!
        
        //Creo Constante para establecer altura de celda
        let alturaCeldaX: CGFloat = alturaCelda - 15
        
        //Creo Constante a la clase Objective-C (Pod)
        let placeHolder = BMInitialsPlaceholderView(diameter: alturaCeldaX)
        
        //Modificamos las propiedades del placeHolder
        placeHolder.circleColor = circleColorForIndexPath (indexPath)
        
        placeHolder.initials = initialsStringForPerrosString (nombreAfijo) as String
        
        //Le Paso al circulo el tipo de fuente
        placeHolder.font = font
        
        //Paso el PlaceHolder como accesoryView de mi celda
        cell.accessoryView = placeHolder
        
        //Paso la fuente y el tamaño a las celdas
        cell.textLabel?.font = font
        
        
        //Presento la información Nombre - Afijo en Pantalla con la imagen del perro
        cell.textLabel?.text = "\(nombre) - \(afijo)"
        
        cell.detailTextLabel?.text = datos.valueForKeyPath("sexo") as? String
        
        cell.imageView?.image = imagen
        
        return cell
    }
    

    
    // Override to support conditional editing of the table view.
    override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return NO if you do not want the specified item to be editable.
        return true
    }

    
    //Funcion que devuelve un color aleatorio para el circulo
    func circleColorForIndexPath (indexPath: NSIndexPath) -> UIColor
    {
        //Creo 3 Variables para almacenar tres valores aleatorios
        var randomRed: CGFloat = CGFloat(drand48())
        var randomGreen: CGFloat = CGFloat(drand48())
        var randomBlue: CGFloat = CGFloat(drand48())
        
        return UIColor(red: randomRed, green: randomGreen,blue: randomBlue, alpha:1.0)
    }

    func initialsStringForPerrosString (perrosString: NSString) -> NSString{
        
        let composicion = perrosString.componentsSeparatedByString(" ")
        
        if (composicion.count >= 2 ){
            let firstName: NSString = composicion[0] as! NSString
            let lastName: NSString = composicion[1] as! NSString
            
            return String(format: "\(firstName.substringToIndex(1))\(lastName.substringToIndex(1))",locale:nil)
        }
        return "Desconocido"
    }
    
    //Permite eliminar registros de mi tabla, actualizando mi modelo de datos
    override func tableView(tableView: UITableView?, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
        
        let appdel: AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        
        let managedObjectContexto : NSManagedObjectContext = appdel.managedObjectContext!
        
        if editingStyle == UITableViewCellEditingStyle.Delete{
            
            if let tableV = tableView{
                
                managedObjectContexto.deleteObject(datosConsultaPerros[indexPath.row] as! NSManagedObject)
                
                datosConsultaPerros.removeAtIndex(indexPath.row)
                
                tableV.deleteRowsAtIndexPaths([indexPath], withRowAnimation: UITableViewRowAnimation.Fade)
            }
            
            var error: NSError? = nil
            
            if !managedObjectContexto.save(&error){
                
                abort ()
                
            }
            
        }
        
        
    }


    /*
    // Override to support rearranging the table view.
    override func tableView(tableView: UITableView, moveRowAtIndexPath fromIndexPath: NSIndexPath, toIndexPath: NSIndexPath) {

    }
    */

    /*
    // Override to support conditional rearranging of the table view.
    override func tableView(tableView: UITableView, canMoveRowAtIndexPath indexPath: NSIndexPath) -> Bool {
        // Return NO if you do not want the item to be re-orderable.
        return true
    }
    */

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using [segue destinationViewController].
        // Pass the selected object to the new view controller.
    }
    */

}
