//
//  ViewControllerDetalleBelleza.swift
//  MyKennel
//
//  Created by Juan Antonio Sánchez Carrillo on 20/6/15.
//  Copyright (c) 2015 Juan Antonio Sánchez Carrillo. All rights reserved.
//

import UIKit
import CoreData

class ViewControllerDetalleBelleza: UIViewController {

    @IBOutlet weak var lugarBellezaEditable: UITextField!
    @IBOutlet weak var claseBellezaEditable: UITextField!
    @IBOutlet weak var juezBellezaEditable: UITextField!
    @IBOutlet weak var resultadoBellezaEditable: UITextField!
    @IBOutlet weak var fechaBellezaEditable: UITextField!
    
    var lugarBelleza : String? = ""
    var claseBelleza : String? = ""
    var juezBelleza : String? = ""
    var resultadoBelleza : String? = ""
    var fechaBelleza : String? = ""

    var existeBelleza : NSManagedObject!

    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        //Pongo la imagen de Fondo
        UIGraphicsBeginImageContext(self.view.frame.size)
        UIImage(named: "Background_4.jpg")?.drawInRect(self.view.bounds)
        var image: UIImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        self.view.backgroundColor = UIColor(patternImage: image)
        
        // Si existe la prueba, muestro los datos por pantalla
        if(existeBelleza != nil)
        {
            lugarBellezaEditable.text = lugarBelleza
            claseBellezaEditable.text = claseBelleza
            juezBellezaEditable.text = juezBelleza
            resultadoBellezaEditable.text = resultadoBelleza
            fechaBellezaEditable.text = fechaBelleza
        }
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: - Métodos Propios

    
    @IBAction func cancelarDetalleBelleza(sender: AnyObject) {
        navigationController?.popToRootViewControllerAnimated(true)

    }
    
    
    @IBAction func guardarDetalleBelleza(sender: AnyObject) {
        //Creo instancia de la clase appdelegate para gestionar la pila de CoreData
        let miDelegate : AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        
        //Creo instancia al objeto Managedeg Objetc Context
        let managedObjectContexto : NSManagedObjectContext = miDelegate.managedObjectContext!
        
        //Creo instancia a la entidad Perro del Core Data
        let entityDescription = NSEntityDescription.entityForName("Belleza", inManagedObjectContext: managedObjectContexto)
        if (existeBelleza != nil){
            
            existeBelleza.setValue(lugarBellezaEditable.text as String, forKey: "lugar")
            existeBelleza.setValue(claseBellezaEditable.text as String, forKey: "clase")
            existeBelleza.setValue(juezBellezaEditable.text as String, forKey: "juez")
            existeBelleza.setValue(resultadoBellezaEditable.text as String, forKey: "resultado")
            existeBelleza.setValue(fechaBellezaEditable.text as String, forKey: "fecha")
            
        }else{
            //Mapeamos nuestras propiedades con los valores del TextField
            //Creamos una instancia de la clase Perros y le asignamos una entidad y un contexto de objeto gestionado
            var newBelleza : Belleza = NSEntityDescription.insertNewObjectForEntityForName("Belleza", inManagedObjectContext: managedObjectContexto) as! Belleza
            newBelleza.lugar = lugarBellezaEditable.text
            newBelleza.clase = claseBellezaEditable.text
            newBelleza.juez = juezBellezaEditable.text
            newBelleza.resultado = resultadoBellezaEditable.text
            newBelleza.fecha = fechaBellezaEditable.text

            
        }
        //Guardamos los valores
        managedObjectContexto.save(nil)
        let alertView = UIAlertView (title: "Guardado Correctamente", message: "Se han guardado correctamente los datos!!!", delegate: nil, cancelButtonTitle: "OK")
        alertView.show()
        
        navigationController?.popToRootViewControllerAnimated(true)
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
