//
//  ViewControllerDetallePerros.swift
//  MyKennel
//
//  Created by Juan Antonio Sánchez Carrillo on 31/5/15.
//  Copyright (c) 2015 Juan Antonio Sánchez Carrillo. All rights reserved.
//

import UIKit
import CoreData


class ViewControllerDetallePerros: UIViewController,UITextFieldDelegate, UINavigationControllerDelegate, UIImagePickerControllerDelegate {
    
    //Declaro las propiedades de la tabla
    //MARK: - Propiedades
    
    @IBOutlet weak var nombrePerroEditable: UITextField!
    @IBOutlet weak var afijoPerroEditable: UITextField!
    @IBOutlet weak var padrePerroEditable: UITextField!
    @IBOutlet weak var madrePerroEditable: UITextField!
    @IBOutlet weak var fechaNacimientoEditable: UITextField!
    @IBOutlet weak var fechaDefuncionEditable: UITextField!
    @IBOutlet weak var sexoEditable: UITextField!
    @IBOutlet weak var loeEditable: UITextField!
    @IBOutlet weak var chipEditable: UITextField!
    
    @IBOutlet weak var imagenPerroEditable: UIImageView!
    
    var nombrePerro : String? = ""
    var afijoPerro : String? = ""
    var padrePerro : String? = ""
    var madrePerro : String? = ""
    var nacimiento : String? = ""
    var defuncion : String? = ""
    var sexo : String? = ""
    var loe : String? = ""
    var chip : String? = ""
    var imagen : UIImage? = UIImage(named: "imagen")
    
    //Variable para comprobar si existe el perro
    var existePerro : NSManagedObject!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        //Pongo la imagen de Fondo
        UIGraphicsBeginImageContext(self.view.frame.size)
        UIImage(named: "Background.png")?.drawInRect(self.view.bounds)
        var image: UIImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        self.view.backgroundColor = UIColor(patternImage: image)
        
        // Si existe el perro, muesto los datos por pantalla
        if(existePerro != nil)
        {
            nombrePerroEditable.text = nombrePerro
            afijoPerroEditable.text = afijoPerro
            padrePerroEditable.text = padrePerro
            madrePerroEditable.text = madrePerro
            fechaNacimientoEditable.text = nacimiento
            fechaDefuncionEditable.text = defuncion
            sexoEditable.text = sexo
            loeEditable.text = loe
            chipEditable.text = chip
            imagenPerroEditable.image = UIImage(named:"imagen")
        }
    
    }
    
    //MARK: - Métodos Propios
    
    @IBAction func guardarDetallePerros(sender: AnyObject) {
        
        //Creo instancia de la clase appdelegate para gestionar la pila de CoreData
        let miDelegate : AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        //Creo instancia al objeto Managedeg Objetc Context
        let managedObjectContexto : NSManagedObjectContext = miDelegate.managedObjectContext!
        //Creo instancia a la entidad Perro del Core Data
        let entityDescription = NSEntityDescription.entityForName("Perros", inManagedObjectContext: managedObjectContexto)
        if (existePerro != nil){
            
            existePerro.setValue(nombrePerroEditable.text as String, forKey: "nombre")
            existePerro.setValue(afijoPerroEditable.text as String, forKey: "afijo")
            existePerro.setValue(padrePerroEditable.text as String, forKey: "padre")
            existePerro.setValue(madrePerroEditable.text as String, forKey: "madre")
            existePerro.setValue(fechaNacimientoEditable.text as String, forKey: "nacimiento")
            existePerro.setValue(fechaDefuncionEditable.text as String, forKey: "defuncion")
            existePerro.setValue(chipEditable.text as String, forKey: "chip")
            existePerro.setValue(sexoEditable.text as String, forKey: "sexo")
            existePerro.setValue(loeEditable.text as String, forKey: "libroOrigenes")
            existePerro.setValue(NSData (data: UIImagePNGRepresentation(imagenPerroEditable.image)),forKey: "imagen")
            
        }else{
            //Mapeamos nuestras propiedades con los valores del TextField
            //Creamos una instancia de la clase Perros y le asignamos una entidad y un contexto de objeto gestionado
            var newPerros : Perros = NSEntityDescription.insertNewObjectForEntityForName("Perros", inManagedObjectContext: managedObjectContexto) as! Perros
            newPerros.nombre = nombrePerroEditable.text
            newPerros.afijo = afijoPerroEditable.text
            newPerros.padre = padrePerroEditable.text
            newPerros.madre = madrePerroEditable.text
            newPerros.sexo = sexoEditable.text
            newPerros.chip = chipEditable.text
            newPerros.libroOrigenes = loeEditable.text
            newPerros.nacimiento = fechaNacimientoEditable.text
            newPerros.defuncion = fechaDefuncionEditable.text
            newPerros.imagen = NSData (data: UIImagePNGRepresentation(imagenPerroEditable.image))
            println(newPerros)
        }
        //Guardamos los valores
        managedObjectContexto.save(nil)
        let alertView = UIAlertView (title: "Guardado Correctamente", message: "Se han guardado correctamente los datos!!!", delegate: nil, cancelButtonTitle: "OK")
        alertView.show()

        navigationController?.popToRootViewControllerAnimated(true)
    }
    
    @IBAction func cancelarDetallePerros(sender: AnyObject) {
        navigationController?.popToRootViewControllerAnimated(true)

    }
    
    
    @IBAction func tomarFoto(sender: AnyObject) {
        
        if UIImagePickerController.isSourceTypeAvailable(UIImagePickerControllerSourceType.PhotoLibrary){
            println("Captura de Botón")
            
            var imag = UIImagePickerController()
            imag.delegate = self
            imag.sourceType = UIImagePickerControllerSourceType.PhotoLibrary;
            imag.allowsEditing = true
            
            self.presentViewController(imag, animated: true, completion: nil)
        }/*else{
            
            var imagi = UIImagePickerController()
            imagi.delegate = self
            imagi.sourceType = UIImagePickerControllerSourceType.PhotoLibrary;
            imagi.allowsEditing = true
            
            self.presentViewController(imagi, animated: true, completion: nil)
            
        }*/
    }
    
    func imagePickerController(picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [NSObject : AnyObject]){
        
        var chosenImage = info[UIImagePickerControllerOriginalImage] as! UIImage
        imagenPerroEditable.contentMode = .ScaleAspectFit
        imagenPerroEditable.image = chosenImage
        dismissViewControllerAnimated(true, completion: nil)
        
        println("Tengo una imagen!!");
    }
    
    
    //Tabula con la tecla aceptar del teclado, si está en el último campo, llama al método de añadir registros
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        
        if textField .isEqual(nombrePerroEditable){
            
            afijoPerroEditable.becomeFirstResponder()
        }
            
        else if textField .isEqual(afijoPerroEditable){
            
            fechaNacimientoEditable.becomeFirstResponder()
        }
            
        else if textField.isEqual(fechaNacimientoEditable){
            
            padrePerroEditable.becomeFirstResponder()
            
        }
            
        else if textField.isEqual(padrePerroEditable){
            
            madrePerroEditable.becomeFirstResponder()
            
        }
            
        else if textField.isEqual(madrePerroEditable){
            
            sexoEditable.becomeFirstResponder()
            
            
        }
        else if textField.isEqual(sexoEditable){
            
            chipEditable.becomeFirstResponder()
            
            
        }
        else if textField.isEqual(chipEditable){
            
            fechaDefuncionEditable.resignFirstResponder()
            
            
        }
        
        
        return true
        
    }

    
    //MARK: - Métodos Delegados
    
    

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
