//
//  ViewControllerDetallePersonas.swift
//  MyKennel
//
//  Created by Juan Antonio Sánchez Carrillo on 20/6/15.
//  Copyright (c) 2015 Juan Antonio Sánchez Carrillo. All rights reserved.
//

import UIKit
import CoreData


class ViewControllerDetallePersonas: UIViewController {

    @IBOutlet weak var nombrePersonaEditable: UITextField!
    @IBOutlet weak var apellidosPersonaEditable: UITextField!
    @IBOutlet weak var telefonoPersonaEditable: UITextField!
    @IBOutlet weak var direccionPersonaEditable: UITextField!
    
    var nombrePersona : String? = ""
    var apellidosPersona : String? = ""
    var telefonoPersona : String? = ""
    var direccionPersona : String? = ""
    
    var existePersona : NSManagedObject!


    
    override func viewDidLoad() {
        super.viewDidLoad()

        //Pongo la imagen de Fondo
        UIGraphicsBeginImageContext(self.view.frame.size)
        UIImage(named: "Background_2.png")?.drawInRect(self.view.bounds)
        var image: UIImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        self.view.backgroundColor = UIColor(patternImage: image)
        
        
        // Si existe la persona, muestro los datos por pantalla
        if(existePersona != nil)
        {
            nombrePersonaEditable.text = nombrePersona
            apellidosPersonaEditable.text = apellidosPersona
            telefonoPersonaEditable.text = telefonoPersona
            direccionPersonaEditable.text = direccionPersona
        }

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: - Métodos Propios
    
    @IBAction func cancelarDetallePropietarios(sender: AnyObject) {
                navigationController?.popToRootViewControllerAnimated(true)
    }
    
    
    @IBAction func guardarDetallePropietarios(sender: AnyObject) {
        
        //Creo instancia de la clase appdelegate para gestionar la pila de CoreData
        let miDelegate : AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        
        //Creo instancia al objeto Managedeg Objetc Context
        let managedObjectContexto : NSManagedObjectContext = miDelegate.managedObjectContext!
        
        //Creo instancia a la entidad Perro del Core Data
        let entityDescription = NSEntityDescription.entityForName("Personas", inManagedObjectContext: managedObjectContexto)
        if (existePersona != nil){
            
            existePersona.setValue(nombrePersonaEditable.text as String, forKey: "nombre")
            existePersona.setValue(apellidosPersonaEditable.text as String, forKey: "apellidos")
            existePersona.setValue(telefonoPersonaEditable.text as String, forKey: "telefono")
            existePersona.setValue(direccionPersonaEditable.text as String, forKey: "direccion")

            
        }else{
            //Mapeamos nuestras propiedades con los valores del TextField
            //Creamos una instancia de la clase Perros y le asignamos una entidad y un contexto de objeto gestionado
            var newPersona : Personas = NSEntityDescription.insertNewObjectForEntityForName("Personas", inManagedObjectContext: managedObjectContexto) as! Personas
            newPersona.nombre = nombrePersonaEditable.text
            newPersona.apellidos = apellidosPersonaEditable.text
            newPersona.telefono = telefonoPersonaEditable.text
            newPersona.direccion = direccionPersonaEditable.text
        }
        //Guardamos los valores
        managedObjectContexto.save(nil)
        let alertView = UIAlertView (title: "Guardado Correctamente", message: "Se han guardado correctamente los datos!!!", delegate: nil, cancelButtonTitle: "OK")
        alertView.show()
        
        navigationController?.popToRootViewControllerAnimated(true)
    }

    //Tabula con la tecla aceptar del teclado, si está en el último campo, llama al método de añadir registros
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        
        if textField .isEqual(nombrePersonaEditable){
            
            apellidosPersonaEditable.becomeFirstResponder()
        }
            
        else if textField .isEqual(apellidosPersonaEditable){
            
            telefonoPersonaEditable.becomeFirstResponder()
        }
            
        else if textField.isEqual(telefonoPersonaEditable){
            
            direccionPersonaEditable.resignFirstResponder()
            
        }
        
        
        return true
        
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
