//
//  ViewControllerDetalleSalud.swift
//  MyKennel
//
//  Created by Juan Antonio Sánchez Carrillo on 20/6/15.
//  Copyright (c) 2015 Juan Antonio Sánchez Carrillo. All rights reserved.
//

import UIKit
import CoreData

class ViewControllerDetalleSalud: UIViewController {

    @IBOutlet weak var nombrePruebaEditable: UITextField!
    @IBOutlet weak var resultadoPruebaEditable: UITextField!
    @IBOutlet weak var fechaPruebaEditable: UITextField!
    
    var nombrePrueba : String? = ""
    var resultadoPrueba : String? = ""
    var fechaPrueba : String? = ""

    var existePrueba : NSManagedObject!

    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        //Pongo la imagen de Fondo
        UIGraphicsBeginImageContext(self.view.frame.size)
        UIImage(named: "Background_3.jpg")?.drawInRect(self.view.bounds)
        var image: UIImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        self.view.backgroundColor = UIColor(patternImage: image)
        
        // Si existe la prueba, muestro los datos por pantalla
        if(existePrueba != nil)
        {
            nombrePruebaEditable.text = nombrePrueba
            resultadoPruebaEditable.text = resultadoPrueba
            fechaPruebaEditable.text = fechaPrueba
        }
        
        
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: - Métodos Propios
    
    @IBAction func cancelarDetalleSalud(sender: AnyObject) {
        navigationController?.popToRootViewControllerAnimated(true)

    }

    
    @IBAction func guardarDetalleSalud(sender: AnyObject) {
        //Creo instancia de la clase appdelegate para gestionar la pila de CoreData
        let miDelegate : AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        
        //Creo instancia al objeto Managedeg Objetc Context
        let managedObjectContexto : NSManagedObjectContext = miDelegate.managedObjectContext!
        
        //Creo instancia a la entidad Salud del Core Data
        let entityDescription = NSEntityDescription.entityForName("Salud", inManagedObjectContext: managedObjectContexto)
        if (existePrueba != nil){
            
            existePrueba.setValue(nombrePruebaEditable.text as String, forKey: "prueba")
            existePrueba.setValue(fechaPruebaEditable.text as String, forKey: "fecha")
            existePrueba.setValue(resultadoPruebaEditable.text as String, forKey: "resultado")
            
        }else{
            //Mapeamos nuestras propiedades con los valores del TextField
            //Creamos una instancia de la clase Perros y le asignamos una entidad y un contexto de objeto gestionado
            var newSalud : Salud = NSEntityDescription.insertNewObjectForEntityForName("Salud", inManagedObjectContext: managedObjectContexto) as! Salud
            newSalud.prueba = nombrePruebaEditable.text
            newSalud.fecha = fechaPruebaEditable.text
            newSalud.resultado = resultadoPruebaEditable.text

        }
        //Guardamos los valores
        managedObjectContexto.save(nil)
        let alertView = UIAlertView (title: "Guardado Correctamente", message: "Se han guardado correctamente los datos!!!", delegate: nil, cancelButtonTitle: "OK")
        alertView.show()
        
        navigationController?.popToRootViewControllerAnimated(true)
    }


}
