//
//  ViewControllerDetalleTrabajo.swift
//  MyKennel
//
//  Created by Juan Antonio Sánchez Carrillo on 20/6/15.
//  Copyright (c) 2015 Juan Antonio Sánchez Carrillo. All rights reserved.
//

import UIKit
import CoreData

class ViewControllerDetalleTrabajo: UIViewController {

    
    @IBOutlet weak var lugarPruebaEditable: UITextField!
    @IBOutlet weak var tipoPruebaEditable: UITextField!
    @IBOutlet weak var juezPruebaEditable: UITextField!
    @IBOutlet weak var resultadoPruebaEditable: UITextField!
    @IBOutlet weak var fechaPruebaEditable: UITextField!
    
    var lugarPrueba : String? = ""
    var tipoPrueba : String? = ""
    var juezPrueba : String? = ""
    var resultadoPrueba : String? = ""
    var fechaPrueba : String? = ""

    var existePrueba : NSManagedObject!

    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        //Pongo la imagen de Fondo
        UIGraphicsBeginImageContext(self.view.frame.size)
        UIImage(named: "Background_5.jpg")?.drawInRect(self.view.bounds)
        var image: UIImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        self.view.backgroundColor = UIColor(patternImage: image)
        
        // Si existe la prueba, muestro los datos por pantalla
        if(existePrueba != nil)
        {
            lugarPruebaEditable.text = lugarPrueba
            tipoPruebaEditable.text = tipoPrueba
            juezPruebaEditable.text = juezPrueba
            resultadoPruebaEditable.text = resultadoPrueba
            fechaPruebaEditable.text = fechaPrueba
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    

    // MARK: - Métodos Propios

    @IBAction func cancelarDetalleTrabajo(sender: AnyObject) {
        navigationController?.popToRootViewControllerAnimated(true)

    }
    
    @IBAction func guardarDetalleTrabajo(sender: AnyObject) {
        //Creo instancia de la clase appdelegate para gestionar la pila de CoreData
        let miDelegate : AppDelegate = UIApplication.sharedApplication().delegate as! AppDelegate
        
        //Creo instancia al objeto Managedeg Objetc Context
        let managedObjectContexto : NSManagedObjectContext = miDelegate.managedObjectContext!
        
        //Creo instancia a la entidad Perro del Core Data
        let entityDescription = NSEntityDescription.entityForName("Belleza", inManagedObjectContext: managedObjectContexto)
        if (existePrueba != nil){
            
            existePrueba.setValue(lugarPruebaEditable.text as String, forKey: "lugar")
            existePrueba.setValue(tipoPruebaEditable.text as String, forKey: "tipo")
            existePrueba.setValue(juezPruebaEditable.text as String, forKey: "juez")
            existePrueba.setValue(resultadoPruebaEditable.text as String, forKey: "resultado")
            existePrueba.setValue(fechaPruebaEditable.text as String, forKey: "fecha")
            
        }else{
            //Mapeamos nuestras propiedades con los valores del TextField
            //Creamos una instancia de la clase Perros y le asignamos una entidad y un contexto de objeto gestionado
            var newTrabajo : Trabajo = NSEntityDescription.insertNewObjectForEntityForName("Trabajo", inManagedObjectContext: managedObjectContexto) as! Trabajo
            newTrabajo.lugar = lugarPruebaEditable.text
            newTrabajo.tipo = tipoPruebaEditable.text
            newTrabajo.juez = juezPruebaEditable.text
            newTrabajo.resultado = resultadoPruebaEditable.text
            newTrabajo.fecha = fechaPruebaEditable.text
            
            
        }
        //Guardamos los valores
        managedObjectContexto.save(nil)
        let alertView = UIAlertView (title: "Guardado Correctamente", message: "Se han guardado correctamente los datos!!!", delegate: nil, cancelButtonTitle: "OK")
        alertView.show()
        
        navigationController?.popToRootViewControllerAnimated(true)
        
    }
    
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
